<?php 
/*
 * colissimo.php - 2010/03 - v1
 *  
 * Module Colissimo pour la France
 * Auteur : Delete - contact > delete forum opencart-france.com - email olivier@smartmarseille.com
 * 
 * Released under the GNU General Public License
 */  

class ControllerShippingColissimo extends Controller { 
	private $error = array();

  public function getCurrentZoneList($country, $departements, $other = false) {
          $output = '';

          if ( ! is_array($departements) ) return ;

          $this->load->model('localisation/zone');

          $results = $this->model_localisation_zone->getZonesByCountryId($country);

          foreach ($results as $result) 
          {
                  if ( $other == true && ! in_array($result['zone_id'], $departements)  ) 
                  {
                    $output .= '<option value="' . $result['zone_id'] . '">' . $result['name'] . '</option>';
                  }
                  elseif ( $other == false && in_array($result['zone_id'], $departements)  ) 
                  {
                    $output .= '<option value="' . $result['zone_id'] . '">' . $result['name'] . '</option>';
                  }

          }

          if (!$results) {
                  $output .= '<option value="0">' . $this->language->get('text_none') . '</option>';
          }

          return $output ;
  }

	public function index() 
  {  
    $this->load->model('localisation/country');
    $this->load->model('localisation/geo_zone');
		$this->load->model('setting/setting');

    $this->data['countries'] = $this->model_localisation_country->getCountries();

		$this->load->language('shipping/colissimo');
    
    $this->document->title = $this->language->get('heading_title');

    
    // Language
    //
		$this->data['button_add'] = $this->language->get('button_add');
		$this->data['button_remove'] = $this->language->get('button_remove');
		
		$this->data['entry_zone'] = $this->language->get('entry_zone');		 
		$this->data['entry_rate'] = $this->language->get('entry_rate');

		$this->data['entry_max_weight'] = $this->language->get('entry_max_weight');
		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		
		$this->data['entry_rate'] = $this->language->get('entry_rate');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		
		$this->data['entry_regions_1'] = $this->language->get('entry_regions_1');
		$this->data['title_regions_1'] = $this->language->get('title_regions_1');


    // Saving Settings
    //    
    if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {

      $settings  = array() ;
      $settings  =  array('country' => $this->request->post['country']) ;
      $settings +=  array('departements' => serialize($this->request->post['departements']))  ;
      $settings +=  array('tax_class_id' => $this->request->post['tax_class_id']) ;
      $settings +=  array('geo_zone_id' => $this->request->post['geo_zone_id']) ;
      $settings +=  array('sort_order' => $this->request->post['sort_order']) ;
      $settings +=  array('max_weight' => $this->request->post['max_weight']) ;
      $settings +=  array('rates_1' => $this->request->post['rates_1']) ;
      $settings +=  array('colissimo_status' => $this->request->post['colissimo_status']) ;
  	 
      $this->model_setting_setting->editSetting('colissimo', $settings);
			
      $this->session->data['success'] = $this->language->get('text_success');
									
			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/shipping');
		}

    // First Installation
    //		
    if ( ! $this->config->get('country') ) 
          $this->_install() ;


 		if (isset($this->request->post['country'])) {
			$this->data['default_country'] = $this->request->post['country'];
		} 
    else 
    {
      $var = $this->config->get('country') ;

			if ( ! $var  ) 
        $this->data['default_country'] = 74 ;
      else 
        $this->data['default_country'] = $this->config->get('country');
		}
		
 		if (isset($this->request->post['departements'])) {
			$this->data['departements'] = $this->request->post['departements'];
		} else {
		  
      $vals = unserialize($this->config->get('departements'))  ;
  
      if ( isset($vals) && is_array($vals) )
      {
        $this->data['saved_departements'] = $this->getCurrentZoneList($this->data['default_country'], $vals) ;
        $this->data['other_departements'] = $this->getCurrentZoneList($this->data['default_country'], $vals, true) ;
			  $this->data['departements'] = $vals ;
  	  }
    }	 
 
 		if (isset($this->request->post['rates_1'])) {
			$this->data['rates_1'] = $this->request->post['rates_1'];
		} else {
			$this->data['rates_1'] = $this->config->get('rates_1');
		}
		
 		if (isset($this->request->post['max_weight'])) 
			$this->data['max_weight'] = $this->request->post['max_weight'];
		else 
		  $this->data['max_weight'] = $this->config->get('max_weight') ;
		

		// Zones
		// 
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');

		if (isset($this->request->post['geo_zone_id'])) {
			$this->data['geo_zone_id'] = $this->request->post['geo_zone_id'];
		} else {
			$this->data['geo_zone_id'] = $this->config->get('geo_zone_id');
		}
 		if (isset($this->request->post['tax_class_id'])) {
			$this->data['tax_class_id'] = $this->request->post['tax_class_id'];
		} else {
			$this->data['tax_class_id'] = $this->config->get('tax_class_id');
		}

  	
		if (isset($this->request->post['colissimo_status'])) {
			$this->data['colissimo_status'] = $this->request->post['colissimo_status'];
		} else {
			$this->data['colissimo_status'] = $this->config->get('colissimo_status');
		}
		
		if (isset($this->request->post['sort_order'])) {
			$this->data['sort_order'] = $this->request->post['sort_order'];
		} else {
			$this->data['sort_order'] = $this->config->get('sort_order');
		}	
 



 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home',
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/shipping',
       		'text'      => $this->language->get('text_shipping'),
      		'separator' => ' :: '
   		);
		
   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=shipping/colissimo',
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=shipping/colissimo';
		
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/shipping'; 

		$this->load->model('localisation/geo_zone');
		
		$geo_zones = $this->model_localisation_geo_zone->getGeoZones();
		
		$this->data['geo_zones'] = $geo_zones;
		
		$this->load->model('localisation/tax_class');
				
		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();
		
		$this->template = 'shipping/colissimo.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}
		
	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/colissimo')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if ( ! $this->request->post['rates_1'] )
  		$this->error['warning'] = $this->language->get('error_rates');

		if ( ! $this->request->post['max_weight'] )
  		$this->error['warning'] = $this->language->get('error_weight');

		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
	
	private function _install()
	{
 		  $this->load->model('setting/setting');

      $settings  = array() ;
      $settings  =  array('country' => '74') ;
      $settings +=  array('departements' => 'a:96:{i:0;s:3:"104";i:1;s:3:"105";i:2;s:3:"106";i:3;s:3:"109";i:4;s:3:"107";i:5;s:3:"110";i:6;s:3:"111";i:7;s:3:"112";i:8;s:3:"113";i:9;s:3:"114";i:10;s:3:"115";i:11;s:3:"171";i:12;s:3:"116";i:13;s:3:"125";i:14;s:3:"126";i:15;s:3:"117";i:16;s:3:"118";i:17;s:3:"119";i:18;s:3:"120";i:19;s:3:"121";i:20;s:3:"122";i:21;s:3:"123";i:22;s:3:"127";i:23;s:3:"183";i:24;s:3:"128";i:25;s:3:"129";i:26;s:3:"130";i:27;s:3:"195";i:28;s:3:"131";i:29;s:3:"132";i:30;s:3:"133";i:31;s:3:"134";i:32;s:3:"136";i:33;s:3:"137";i:34;s:3:"202";i:35;s:3:"138";i:36;s:3:"172";i:37;s:3:"124";i:38;s:3:"135";i:39;s:3:"147";i:40;s:3:"156";i:41;s:3:"174";i:42;s:3:"178";i:43;s:3:"191";i:44;s:3:"108";i:45;s:3:"169";i:46;s:3:"196";i:47;s:3:"139";i:48;s:3:"140";i:49;s:3:"141";i:50;s:3:"142";i:51;s:3:"143";i:52;s:3:"144";i:53;s:3:"145";i:54;s:3:"146";i:55;s:3:"148";i:56;s:3:"149";i:57;s:3:"150";i:58;s:3:"151";i:59;s:3:"152";i:60;s:3:"153";i:61;s:3:"154";i:62;s:3:"155";i:63;s:3:"158";i:64;s:3:"159";i:65;s:3:"160";i:66;s:3:"161";i:67;s:3:"162";i:68;s:3:"163";i:69;s:3:"164";i:70;s:3:"165";i:71;s:3:"179";i:72;s:3:"166";i:73;s:3:"167";i:74;s:3:"168";i:75;s:3:"170";i:76;s:3:"173";i:77;s:3:"175";i:78;s:3:"176";i:79;s:3:"177";i:80;s:3:"180";i:81;s:3:"197";i:82;s:3:"181";i:83;s:3:"184";i:84;s:3:"185";i:85;s:3:"186";i:86;s:3:"194";i:87;s:3:"199";i:88;s:3:"198";i:89;s:3:"187";i:90;s:3:"188";i:91;s:3:"189";i:92;s:3:"190";i:93;s:3:"192";i:94;s:3:"193";i:95;s:3:"182";}') ;
      $settings +=  array('geo_zone_id' => '6') ;
      $settings +=  array('max_weight' => '30') ;
      $settings +=  array('rates_1' => '0.500:5.55, 1:6.80, 2:7.75, 3:8.70, 5:10.60, 7:12.50, 10:15.35, 15:17.45, 30:23.75') ;
  	 
      $this->model_setting_setting->editSetting('colissimo', $settings);
	
      $this->redirect(HTTPS_SERVER . 'index.php?route=shipping/colissimo');
  }
}
?>